/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javamap;

import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TreeMap;

/**
 *
 * @author yunglu
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        Map<String, Integer> histogram = new TreeMap<String, Integer>();  //(A)
        String allChars = ""; // must be defined outside try-catch
        if (args.length > 0) {
            try {
                allChars = getAllChars(args[0]);                 //(B)
            } catch (IOException ioe) {
                System.out.println("caught IOException");
            // exception handling in Chapter 10
            }
        }
        StringTokenizer st = new StringTokenizer(allChars);     //(C)
        while (st.hasMoreTokens()) {                            //(D)
            String word = st.nextToken();                         //(E)
            Integer count = (Integer) histogram.get(word);      //(F)
            histogram.put(word, (count == null ? new Integer(1)
                    : new Integer(count.intValue() + 1)));     //(G)
        }
        System.out.println("Total number of DISTINCT words: " + histogram.size()); //(H)
        System.out.println(histogram);                          //(I)
    }

    static String getAllChars(String filename) throws IOException {
        String str = "";
        int ch;
        Reader input = new FileReader(filename);
        while ((ch = input.read()) != -1) {
            str += (char) ch;
        }
        input.close();
        return str;
    }
}
